module ExoBasic
  class JsonHttp
    def self.is_success_raw?(code)
      code >= 200 && code < 300
    end

    def self.is_success?(code)
      begin
        JsonHttp.is_success_raw?(code.to_i)
      rescue
        false
      end
    end

    def self.mk_http_return
      {
        :http_return => 0,
        :warnings => [],
        :errors => [],
        :body => {}
      }
    end

    def self.append_http_error(result, code, err)
      result[:http_return] = code
      result[:errors].push(err)

      true
    end

    def self.append_http_errors(result, code, errs)
      result[:http_return] = code
      result[:errors]     += errs

      true
    end

    def self.append_http_body(result, k, v)
      result[:http_return] = 200
      result[:body][k]     = v

      false
    end

    def self.set_http_body(result, h)
      result[:http_return] = 200
      result[:body]        = h

      false
    end

    def self.mk_result
      {
        :success => true,
        :errors => [],
        :warnings => [],
        :body => {}
      }
    end

    def self.append_result_error(result, err)
      result[:success] = false
      result[:errors].push(err)

      true
    end

    def self.append_result_errors(result, errs)
      result[:success] = false
      result[:errors]  += errs

      true
    end

    def self.append_result_body(result, k, v)
      result[:success] = true
      result[:body][k] = v

      false
    end

    def self.set_result_body(result, h)
      result[:success] = true
      result[:body]    = h

      false
    end

  end
end
