module ExoBasic
  class StatsHelpers
    def self.double_equals(a1, a2)
      (a1 - a2).abs < 1e-4
    end
  end

  module AvgTraits
    def count
      self.meta.n
    end

    def minimum
      self.meta.possibilityRange[0]
    end

    def maximum
      self.meta.possibilityRange[1]
    end

    def approx=(other)
      StatsHelpers.double_equals(self.avg, other.avg)
    end

    def deep_copy
      Marshal.load(Marshal.dump(self))
    end

    def offer_many(xs)
      xs.each { |x| self.offer(x) }
    end

  end
end
