module ExoBasic
  class DecayingAvg
    include AvgTraits

    attr_reader :d, :avg, :meta

    DEFAULT_D = 12

    def initialize(d=DEFAULT_D)
      @d    = d <= 0 ? DEFAULT_D : d
      @avg  = 0.0
      @meta = AvgMeta.new
    end

    def d=(d)
      @d = d <= 0 ? DecayingAvg::DEFAULT_D : d
    end

    def offer(x)
      @meta = @meta.offer(x, @avg, d)

      d_prime = @d.to_f
      @avg    = x / d_prime + (d_prime - 1.0) * @avg / d_prime
    end

    def ==(other)
      @d == other.d &&
      StatsHelpers.double_equals(@avg, other.avg) &&
      @meta == other.meta
    end

  end
end
