module ExoBasic
  class MeanAvg
    include AvgTraits

    attr_reader :avg, :meta

    def initialize
      @avg  = 0.0
      @meta = AvgMeta.new
    end

    def from_hash(h)
      @avg  = h[:avg]
      @meta = h[:meta]
    end

    def self.mk(h)
      x = MeanAvg.new
      x.from_hash(h)

      x
    end

    def offer(x)
      n     = @meta.n + 1
      @meta = @meta.offer(x, @avg, n)

      n_prime = n.to_f
      @avg    = x / n_prime + (n_prime - 1.0) * @avg / n_prime
    end

    def ==(other)
      StatsHelpers.double_equals(@avg, other.avg) &&
      @meta == other.meta
    end

    def +(other)
      n_prime = @meta.n + other.meta.n

      MeanAvg.mk({
        :avg => n_prime == 0 ? 0.0 : (@avg * @meta.n + other.avg * other.meta.n) / n_prime.to_f,
        :meta => @meta + other.meta
      })
    end

  end
end
