module ExoBasic
  class ShortTermAvg
    include AvgTraits

    attr_reader :d, :history, :meta

    DEFAULT_D = 12

    def initialize(d=DEFAULT_D)
      @d       = d <= 0 ? DEFAULT_D : d
      @history = []
      @meta    = AvgMeta.new
    end

    def d=(d)
      @d       = d <= 0 ? ShortTermAvg::DEFAULT_D : d
      @history = @history[0..@d - 1]
    end

    def avg
      history.empty? ? 0.0 : history.sum / history.length.to_f
    end

    def offer(x)
      siz = history.length
      if siz < @d
        history.push(x)
      else
        history = history[1..-2].push(x)
      end

      @meta = @meta.offer(x, self.avg, siz)
    end

    def ==(other)
      @d == other.d &&
      (@history <=> other.history) == 0 &&
      @meta == other.meta
    end

  end
end
